From 6a16454e0672e818423f6485fb14f4aa6f782aed Mon Sep 17 00:00:00 2001
From: Daniel Gustafsson <dgustafsson@postgresql.org>
Date: Fri, 15 Aug 2025 14:48:02 +0200
Subject: [PATCH v20260305] Online enabling and disabling of data checksums

This allows data checksums to be enabled, or disabled, in a running
cluster without restricting access to the cluster during processing.

Data checksums could prior to this only be enabled during initdb or
when the cluster is offline using the pg_checksums app. This commit
introduce functionality to enable, or disable, data checksums while
the cluster is running regardless of how it was initialized.

A background worker launcher process is responsible for launching a
dynamic per-database background worker which will mark all buffers
dirty for all relation with storage in order for them to have data
checksums calcuated on write.  Once all relations in all databases
have been processed, the data_checksums state will be set to on and
the cluster will at that point be identical to one which had data
checksums enabled during initialization or via offline processing.

When data checksums are being enabled, concurrent I/O operations
from backends other than the data checksums worker will write the
checksums but not verify them on reading.  Only when all backends
have absorbed the procsignalbarrier for setting data_checksums to
on will they also start verifying checksums on reading.  The same
process is repeated during disabling; all backends write checksums
but do not verify them until the barrier for setting the state to
off has been absorbed by all.  This in-progress state is used to
ensure there are no false negatives (or positives) due to reading
a checksum which is not in sync with the page.

A new testmodule, test_checksums, is introduced with an extensive
set of tests covering both online and offline data checksum mode
changes.  The tests for online processing are gated begind the
PG_TEST_EXTRA flag to some degree due to being very time consuming
to run.

This work is based on an earlier version of this patch which was
reviewed by among others Heikki Linnakangas, Robert Haas, Andres
Freund, Tomas Vondra, Michael Banck and Andrey Borodin.  During
the work on this new version, Tomas Vondra has given invaluable
assistance with not only coding and reviewing but very in-depth
testing.

Author: Daniel Gustafsson <daniel@yesql.se>
Author: Magnus Hagander <magnus@hagander.net>
Co-authored-by: Tomas Vondra <tomas@vondra.me>
Reviewed-by: Tomas Vondra <tomas@vondra.me>
Reviewed-by: Andres Freund <andres@anarazel.de>
Discussion: https://postgr.es/m/CABUevExz9hUUOLnJVr2kpw9Cx=o4MCr1SVKwbupzuxP7ckNutA@mail.gmail.com
Discussion: https://postgr.es/m/20181030051643.elbxjww5jjgnjaxg@alap3.anarazel.de
Discussion: https://postgr.es/m/CABUevEwE3urLtwxxqdgd5O2oQz9J717ZzMbh+ziCSa5YLLU_BA@mail.gmail.com
---
 doc/src/sgml/func/func-admin.sgml             |   77 +
 doc/src/sgml/glossary.sgml                    |   24 +
 doc/src/sgml/images/Makefile                  |    1 +
 doc/src/sgml/images/datachecksums.gv          |   14 +
 doc/src/sgml/images/datachecksums.svg         |   81 +
 doc/src/sgml/monitoring.sgml                  |  235 ++-
 doc/src/sgml/ref/pg_checksums.sgml            |    6 +
 doc/src/sgml/regress.sgml                     |   12 +
 doc/src/sgml/wal.sgml                         |  127 +-
 src/backend/access/rmgrdesc/xlogdesc.c        |   42 +-
 src/backend/access/transam/xlog.c             |  718 +++++++-
 src/backend/access/transam/xlogfuncs.c        |   48 +
 src/backend/access/transam/xlogrecovery.c     |    1 +
 src/backend/backup/basebackup.c               |   27 +-
 src/backend/catalog/system_functions.sql      |   12 +
 src/backend/catalog/system_views.sql          |   19 +
 src/backend/postmaster/Makefile               |    1 +
 src/backend/postmaster/auxprocess.c           |   19 +
 src/backend/postmaster/bgworker.c             |    9 +
 src/backend/postmaster/datachecksumsworker.c  | 1487 +++++++++++++++++
 src/backend/postmaster/meson.build            |    1 +
 src/backend/postmaster/postmaster.c           |    5 +
 src/backend/postmaster/walsummarizer.c        |    5 +-
 src/backend/replication/logical/decode.c      |    1 +
 src/backend/storage/ipc/ipci.c                |    3 +
 src/backend/storage/ipc/procsignal.c          |   14 +
 src/backend/storage/page/README               |    4 +-
 src/backend/storage/page/bufpage.c            |   22 +-
 src/backend/utils/activity/pgstat_backend.c   |    2 +
 src/backend/utils/activity/pgstat_io.c        |    2 +
 .../utils/activity/wait_event_names.txt       |    4 +
 src/backend/utils/adt/pgstatfuncs.c           |    8 +-
 src/backend/utils/init/miscinit.c             |    3 +-
 src/backend/utils/init/postinit.c             |   20 +-
 src/backend/utils/misc/guc_parameters.dat     |    5 +-
 src/backend/utils/misc/guc_tables.c           |    9 +-
 src/bin/pg_checksums/pg_checksums.c           |    4 +-
 src/bin/pg_controldata/pg_controldata.c       |    2 +
 src/bin/pg_upgrade/controldata.c              |    9 +
 src/include/access/xlog.h                     |   14 +-
 src/include/access/xlog_internal.h            |   13 +
 src/include/catalog/pg_control.h              |    6 +-
 src/include/catalog/pg_proc.dat               |   12 +
 src/include/commands/progress.h               |   16 +
 src/include/miscadmin.h                       |    6 +
 src/include/postmaster/datachecksumsworker.h  |   50 +
 src/include/postmaster/proctypelist.h         |    2 +
 src/include/storage/bufpage.h                 |    2 +-
 src/include/storage/checksum.h                |   14 +
 src/include/storage/lwlocklist.h              |    1 +
 src/include/storage/proc.h                    |    3 +-
 src/include/storage/procsignal.h              |    4 +
 src/include/utils/backend_progress.h          |    1 +
 src/test/modules/Makefile                     |    1 +
 src/test/modules/meson.build                  |    1 +
 src/test/modules/test_checksums/.gitignore    |    2 +
 src/test/modules/test_checksums/Makefile      |   40 +
 src/test/modules/test_checksums/README        |   30 +
 src/test/modules/test_checksums/meson.build   |   36 +
 .../modules/test_checksums/t/001_basic.pl     |   63 +
 .../modules/test_checksums/t/002_restarts.pl  |  110 ++
 .../test_checksums/t/003_standby_restarts.pl  |  114 ++
 .../modules/test_checksums/t/004_offline.pl   |   82 +
 .../modules/test_checksums/t/005_injection.pl |  109 ++
 .../test_checksums/t/006_pgbench_single.pl    |  252 +++
 .../test_checksums/t/007_pgbench_standby.pl   |  376 +++++
 .../test_checksums/t/DataChecksums/Utils.pm   |  261 +++
 .../test_checksums/test_checksums--1.0.sql    |   28 +
 .../modules/test_checksums/test_checksums.c   |  222 +++
 .../test_checksums/test_checksums.control     |    4 +
 src/test/perl/PostgreSQL/Test/Cluster.pm      |   36 +
 src/test/regress/expected/rules.out           |   35 +
 src/test/regress/expected/stats.out           |   18 +-
 src/tools/pgindent/typedefs.list              |    9 +
 74 files changed, 4997 insertions(+), 59 deletions(-)
 create mode 100644 doc/src/sgml/images/datachecksums.gv
 create mode 100644 doc/src/sgml/images/datachecksums.svg
 create mode 100644 src/backend/postmaster/datachecksumsworker.c
 create mode 100644 src/include/postmaster/datachecksumsworker.h
 create mode 100644 src/test/modules/test_checksums/.gitignore
 create mode 100644 src/test/modules/test_checksums/Makefile
 create mode 100644 src/test/modules/test_checksums/README
 create mode 100644 src/test/modules/test_checksums/meson.build
 create mode 100644 src/test/modules/test_checksums/t/001_basic.pl
 create mode 100644 src/test/modules/test_checksums/t/002_restarts.pl
 create mode 100644 src/test/modules/test_checksums/t/003_standby_restarts.pl
 create mode 100644 src/test/modules/test_checksums/t/004_offline.pl
 create mode 100644 src/test/modules/test_checksums/t/005_injection.pl
 create mode 100644 src/test/modules/test_checksums/t/006_pgbench_single.pl
 create mode 100644 src/test/modules/test_checksums/t/007_pgbench_standby.pl
 create mode 100644 src/test/modules/test_checksums/t/DataChecksums/Utils.pm
 create mode 100644 src/test/modules/test_checksums/test_checksums--1.0.sql
 create mode 100644 src/test/modules/test_checksums/test_checksums.c
 create mode 100644 src/test/modules/test_checksums/test_checksums.control

diff --git a/doc/src/sgml/func/func-admin.sgml b/doc/src/sgml/func/func-admin.sgml
index 3ac81905d1f..7762b774bf2 100644
--- a/doc/src/sgml/func/func-admin.sgml
+++ b/doc/src/sgml/func/func-admin.sgml
@@ -3087,4 +3087,81 @@ SELECT convert_from(pg_read_binary_file('file_in_utf8.txt'), 'UTF8');
 
   </sect2>
 
+  <sect2 id="functions-admin-checksum">
+   <title>Data Checksum Functions</title>
+
+   <para>
+    The functions shown in <xref linkend="functions-checksums-table" /> can
+    be used to enable or disable data checksums in a running cluster.
+   </para>
+   <para>
+    Changing data checksums can be done in a cluster with concurrent activity
+    without blocking queries, but overall system performance will be affected.
+    See <xref linkend="checksums" /> for further details on how changing the
+    data checksums mode can affect a system and possible mitigations for how
+    to reduce the impact.
+   </para>
+
+   <table id="functions-checksums-table">
+    <title>Data Checksum Functions</title>
+    <tgroup cols="1">
+     <thead>
+      <row>
+       <entry role="func_table_entry"><para role="func_signature">
+        Function
+       </para>
+       <para>
+        Description
+       </para></entry>
+      </row>
+     </thead>
+
+     <tbody>
+      <row>
+       <entry role="func_table_entry"><para role="func_signature">
+        <indexterm>
+         <primary>pg_enable_data_checksums</primary>
+        </indexterm>
+        <function>pg_enable_data_checksums</function> ( <optional><parameter>cost_delay</parameter> <type>int</type>, <parameter>cost_limit</parameter> <type>int</type></optional> )
+        <returnvalue>void</returnvalue>
+       </para>
+       <para>
+        Initiates the process of enabling data checksums for the cluster. This
+        will set the data checksums mode to <literal>inprogress-on</literal>
+        as well as start a background worker that will process all pages in all
+        databases and enable data checksums on them.  When all data checksums
+        have been calculated, and written, for all pages the cluster will
+        automatically set data checksums mode to <literal>on</literal>.
+       </para>
+       <para>
+        If <parameter>cost_delay</parameter> and <parameter>cost_limit</parameter> are
+        specified, the process is throttled using the same principles as
+        <link linkend="runtime-config-resource-vacuum-cost">Cost-based Vacuum Delay</link>.
+       </para>
+       </entry>
+      </row>
+
+      <row>
+       <entry role="func_table_entry"><para role="func_signature">
+        <indexterm>
+         <primary>pg_disable_data_checksums</primary>
+        </indexterm>
+        <function>pg_disable_data_checksums</function> ()
+        <returnvalue>void</returnvalue>
+       </para>
+       <para>
+        Disables data checksum calculation and validation for the cluster. This
+        will set the data checksum mode to <literal>inprogress-off</literal>
+        while data checksums are being disabled.  When all active backends have
+        stopped validating data checksums, the data checksum mode will be
+        set to <literal>off</literal>.
+       </para>
+       </entry>
+      </row>
+     </tbody>
+    </tgroup>
+   </table>
+
+  </sect2>
+
   </sect1>
diff --git a/doc/src/sgml/glossary.sgml b/doc/src/sgml/glossary.sgml
index e2db5bcc78c..d9378af0606 100644
--- a/doc/src/sgml/glossary.sgml
+++ b/doc/src/sgml/glossary.sgml
@@ -199,6 +199,8 @@
      (but not the autovacuum workers),
      the <glossterm linkend="glossary-background-writer">background writer</glossterm>,
      the <glossterm linkend="glossary-checkpointer">checkpointer</glossterm>,
+     the <glossterm linkend="glossary-data-checksums-worker">data checksums worker</glossterm>,
+     the <glossterm linkend="glossary-data-checksums-worker-launcher">data checksums worker launcher</glossterm>,
      the <glossterm linkend="glossary-logger">logger</glossterm>,
      the <glossterm linkend="glossary-startup-process">startup process</glossterm>,
      the <glossterm linkend="glossary-wal-archiver">WAL archiver</glossterm>,
@@ -574,6 +576,28 @@
    <glosssee otherterm="glossary-data-directory" />
   </glossentry>
 
+  <glossentry id="glossary-data-checksums-worker">
+   <glossterm>Data Checksums Worker</glossterm>
+   <glossdef>
+    <para>
+     A <glossterm linkend="glossary-background-worker">background worker</glossterm>
+     which enables data checksums in a specific database.
+    </para>
+   </glossdef>
+  </glossentry>
+
+  <glossentry id="glossary-data-checksums-worker-launcher">
+   <glossterm>Data Checksums Worker Launcher</glossterm>
+   <glossdef>
+    <para>
+     A <glossterm linkend="glossary-background-worker">background worker</glossterm>
+     which starts <glossterm linkend="glossary-data-checksums-worker"> data
+     checksum worker</glossterm> processes for enabling data checksums in each
+     database, or disables data checksums cluster-wide.
+    </para>
+   </glossdef>
+  </glossentry>
+
   <glossentry id="glossary-database">
    <glossterm>Database</glossterm>
    <glossdef>
diff --git a/doc/src/sgml/images/Makefile b/doc/src/sgml/images/Makefile
index fd55b9ad23f..e805487344d 100644
--- a/doc/src/sgml/images/Makefile
+++ b/doc/src/sgml/images/Makefile
@@ -3,6 +3,7 @@
 # see README in this directory about image handling
 
 ALL_IMAGES = \
+	datachecksums.svg \
 	genetic-algorithm.svg \
 	gin.svg \
 	pagelayout.svg \
diff --git a/doc/src/sgml/images/datachecksums.gv b/doc/src/sgml/images/datachecksums.gv
new file mode 100644
index 00000000000..dff3ff7340a
--- /dev/null
+++ b/doc/src/sgml/images/datachecksums.gv
@@ -0,0 +1,14 @@
+digraph G {
+    A -> B [label="SELECT pg_enable_data_checksums()"];
+    B -> C;
+    D -> A;
+    C -> D [label="SELECT pg_disable_data_checksums()"];
+    E -> A [label=" --no-data-checksums"];
+    E -> C [label=" --data-checksums"];
+
+    A [label="off"];
+    B [label="inprogress-on"];
+    C [label="on"];
+    D [label="inprogress-off"];
+    E [label="initdb"];
+}
diff --git a/doc/src/sgml/monitoring.sgml b/doc/src/sgml/monitoring.sgml
index b77d189a500..49a38c6a136 100644
--- a/doc/src/sgml/monitoring.sgml
+++ b/doc/src/sgml/monitoring.sgml
@@ -3622,9 +3622,14 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       </para>
       <para>
        Number of data page checksum failures detected in this
-       database (or on a shared object), or NULL if data checksums are
-       disabled.
-      </para></entry>
+       database (or on a shared object).  Detected failures are not reset if
+       the <xref linkend="guc-data-checksums"/> setting changes.  Clusters
+       which are initialized without data checksums will show this as
+       <literal>0</literal>. In <productname>PostgreSQL</productname> version
+       18 and earlier, this was set to <literal>NULL</literal> for clusters
+       with data checksums disabled.
+      </para>
+     </entry>
      </row>
 
      <row>
@@ -3633,8 +3638,8 @@ description | Waiting for a newly initialized WAL file to reach durable storage
       </para>
       <para>
        Time at which the last data page checksum failure was detected in
-       this database (or on a shared object), or NULL if data checksums are
-       disabled.
+       this database (or on a shared object). Last failure is reported
+       regardless of the <xref linkend="guc-data-checksums"/> setting.
       </para></entry>
      </row>
 
@@ -7117,6 +7122,226 @@ FROM pg_stat_get_backend_idset() AS backendid;
 
  </sect2>
 
+ <sect2 id="data-checksum-progress-reporting">
+  <title>Data Checksum Progress Reporting</title>
+
+  <indexterm>
+   <primary>pg_stat_progress_data_checksums</primary>
+  </indexterm>
+
+  <para>
+   When data checksums are being enabled on a running cluster, the
+   <structname>pg_stat_progress_data_checksums</structname> view will contain
+   a row for the launcher process, and one row for each worker process which
+   is currently calculating and writing checksums for the data pages in a database.
+   The launcher provides overview of the overall progress (how many databases
+   have been processed, how many remain), while the workers track progress for
+   currently processed databases.
+  </para>
+
+  <table id="pg-stat-progress-data-checksums-view" xreflabel="pg_stat_progress_data_checksums">
+   <title><structname>pg_stat_progress_data_checksums</structname> View</title>
+   <tgroup cols="1">
+    <thead>
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        Column Type
+       </para>
+       <para>
+        Description
+       </para>
+      </entry>
+     </row>
+    </thead>
+
+    <tbody>
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>pid</structfield> <type>integer</type>
+       </para>
+       <para>
+        Process ID of the data checksum process, launcher or worker.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>datid</structfield> <type>oid</type>
+       </para>
+       <para>
+        OID of this database, or <literal>0</literal> for the launcher process.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>datname</structfield> <type>name</type>
+       </para>
+       <para>
+        Name of this database, or <literal>NULL</literal> for the
+        launcher process.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>phase</structfield> <type>text</type>
+       </para>
+       <para>
+        Current processing phase, see <xref linkend="datachecksum-phases"/>
+        for description of the phases.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>databases_total</structfield> <type>integer</type>
+       </para>
+       <para>
+        The total number of databases which will be processed. Only the
+        launcher process has this value set, the worker processes have this
+        set to <literal>NULL</literal>.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>databases_done</structfield> <type>integer</type>
+       </para>
+       <para>
+        The number of databases which have been processed. Only the launcher
+        process has this value set, the worker processes have this set to
+        <literal>NULL</literal>.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>relations_total</structfield> <type>integer</type>
+       </para>
+       <para>
+        The total number of relations which will be processed, or
+        <literal>NULL</literal> if the worker process hasn't
+        calculated the number of relations yet. The launcher process has
+        this set to <literal>NULL</literal> since it isn't responsible for
+        processing relations, only launching worker processes.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>relations_done</structfield> <type>integer</type>
+       </para>
+       <para>
+        The number of relations which have been processed. The launcher
+        process has this set to <literal>NULL</literal>.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>blocks_total</structfield> <type>integer</type>
+       </para>
+       <para>
+        The number of blocks in the current relation which will be processed,
+        or <literal>NULL</literal> if the worker process hasn't
+        calculated the number of blocks yet. The launcher process has
+        this set to <literal>NULL</literal>.
+       </para>
+      </entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry">
+       <para role="column_definition">
+        <structfield>blocks_done</structfield> <type>integer</type>
+       </para>
+       <para>
+        The number of blocks in the current relation which have been processed.
+        The launcher process has this set to <literal>NULL</literal>.
+       </para>
+      </entry>
+     </row>
+
+    </tbody>
+   </tgroup>
+  </table>
+
+  <table id="datachecksum-phases">
+   <title>Data Checksum Phases</title>
+   <tgroup cols="2">
+    <colspec colname="col1" colwidth="1*"/>
+    <colspec colname="col2" colwidth="2*"/>
+    <thead>
+     <row>
+      <entry>Phase</entry>
+      <entry>Description</entry>
+     </row>
+    </thead>
+    <tbody>
+     <row>
+      <entry><literal>enabling</literal></entry>
+      <entry>
+       The command is currently enabling data checksums on the cluster.
+      </entry>
+     </row>
+     <row>
+      <entry><literal>disabling</literal></entry>
+      <entry>
+       The command is currently disabling data checksums on the cluster.
+      </entry>
+     </row>
+     <row>
+      <entry><literal>done</literal></entry>
+      <entry>
+       The command is done and the data checksum state in the cluster has
+       changed.
+      </entry>
+     </row>
+     <row>
+      <entry><literal>waiting on barrier</literal></entry>
+      <entry>
+       The command is currently waiting for the current active backends to
+       acknowledge the change in data checksum state.
+      </entry>
+     </row>
+     <row>
+      <entry><literal>waiting on checkpoint</literal></entry>
+      <entry>
+       The command is currently waiting for a checkpoint to update the checksum
+       state before finishing.
+      </entry>
+     </row>
+     <row>
+      <entry><literal>waiting on temporary tables</literal></entry>
+      <entry>
+       The command is currently waiting for all temporary tables which existed
+       at the time the command was started to be removed.
+      </entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+ </sect2>
+
  </sect1>
 
  <sect1 id="dynamic-trace">
diff --git a/doc/src/sgml/ref/pg_checksums.sgml b/doc/src/sgml/ref/pg_checksums.sgml
index e9e393495df..e764b8be04d 100644
--- a/doc/src/sgml/ref/pg_checksums.sgml
+++ b/doc/src/sgml/ref/pg_checksums.sgml
@@ -45,6 +45,12 @@ PostgreSQL documentation
    exit status is nonzero if the operation failed.
   </para>
 
+  <para>
+   When enabling checksums, if checksums were in the process of being enabled
+   when the cluster was shut down, <application>pg_checksums</application>
+   will still process all relations regardless of the online processing.
+  </para>
+
   <para>
    When verifying checksums, every file in the cluster is scanned. When
    enabling checksums, each relation file block with a changed checksum is
diff --git a/doc/src/sgml/regress.sgml b/doc/src/sgml/regress.sgml
index d80dd46c5fd..26cf1c2868c 100644
--- a/doc/src/sgml/regress.sgml
+++ b/doc/src/sgml/regress.sgml
@@ -275,6 +275,18 @@ make check-world PG_TEST_EXTRA='kerberos ldap ssl load_balance libpq_encryption'
 </programlisting>
    The following values are currently supported:
    <variablelist>
+    <varlistentry>
+     <term><literal>checksum_extended</literal></term>
+     <listitem>
+      <para>
+       Runs additional tests for enabling data checksums which inject delays
+       and re-tries in the processing, as well as tests that run pgbench
+       concurrently and randomly restarts the cluster.  Some of these test
+       suites require injection points enabled in the installation.
+      </para>
+     </listitem>
+    </varlistentry>
+
     <varlistentry>
      <term><literal>kerberos</literal></term>
      <listitem>
diff --git a/doc/src/sgml/wal.sgml b/doc/src/sgml/wal.sgml
index f3b86b26be9..df41fb54cb6 100644
--- a/doc/src/sgml/wal.sgml
+++ b/doc/src/sgml/wal.sgml
@@ -246,9 +246,10 @@
   <para>
    Checksums can be disabled when the cluster is initialized using <link
    linkend="app-initdb-data-checksums"><application>initdb</application></link>.
-   They can also be enabled or disabled at a later time as an offline
-   operation. Data checksums are enabled or disabled at the full cluster
-   level, and cannot be specified individually for databases or tables.
+   They can also be enabled or disabled at a later time either as an offline
+   operation or online in a running cluster allowing concurrent access. Data
+   checksums are enabled or disabled at the full cluster level, and cannot be
+   specified individually for databases or tables.
   </para>
 
   <para>
@@ -265,7 +266,7 @@
   </para>
 
   <sect2 id="checksums-offline-enable-disable">
-   <title>Off-line Enabling of Checksums</title>
+   <title>Offline Enabling of Checksums</title>
 
    <para>
     The <link linkend="app-pgchecksums"><application>pg_checksums</application></link>
@@ -274,6 +275,124 @@
    </para>
 
   </sect2>
+
+  <sect2 id="checksums-online-enable-disable">
+   <title>Online Enabling of Checksums</title>
+
+   <para>
+    Checksums can be enabled or disabled online, by calling the appropriate
+    <link linkend="functions-admin-checksum">functions</link>.
+   </para>
+
+   <para>
+    Both enabling and disabling data checksums happens in two phases, separated
+    by a checkpoint to ensure durability.  The different states, and their
+    transitions, are illustrated in <xref linkend="data-checksums-states-figure"/>
+    and discussed in further detail in this section.
+   </para>
+
+   <para>
+    <figure id="data-checksums-states-figure">
+     <title>data checksums states</title>
+     <mediaobject>
+      <imageobject>
+       <imagedata fileref="images/datachecksums.svg" format="SVG" width="100%"/>
+      </imageobject>
+     </mediaobject>
+    </figure>
+   </para>
+
+   <para>
+    Enabling checksums will put the cluster checksum mode in
+    <literal>inprogress-on</literal> mode.  During this time, checksums will be
+    written but not verified. In addition to this, a background worker process
+    is started that enables checksums on all existing data in the cluster. Once
+    this worker has completed processing all databases in the cluster, the
+    checksum mode will automatically switch to <literal>on</literal>. The
+    processing will consume two background worker processes, make sure that
+    <varname>max_worker_processes</varname> allows for at least two more
+    additional processes.
+   </para>
+
+   <para>
+    The process will initially wait for all open transactions to finish before
+    it starts, so that it can be certain that there are no tables that have been
+    created inside a transaction that has not committed yet and thus would not
+    be visible to the process enabling checksums. It will also, for each database,
+    wait for all pre-existing temporary tables to get removed before it finishes.
+    If long-lived temporary tables are used in the application it may be necessary
+    to terminate these application connections to allow the process to complete.
+   </para>
+
+   <para>
+    If the cluster is stopped while in <literal>inprogress-on</literal> mode,
+    for any reason, then the checksum enable process must be restarted manually.
+    To do this, re-execute the function <function>pg_enable_data_checksums()</function>
+    once the cluster has been restarted. The process will start over, there is
+    no support for resuming work from where it was interrupted.  If the cluster
+    is stopped while in <literal>inprogress-off</literal>, then the checksum
+    state will be set to <literal>off</literal> when the cluster is
+    restarted.
+   </para>
+
+   <para>
+    Disabling data checksums will set the data checksum mode to
+    <literal>inprogress-off</literal>.  During this time, checksums will be
+    written but not verified.  After all processes acknowledge the change,
+    the mode will automatically be set to <literal>off</literal>.
+   </para>
+
+   <para>
+    Disabling data checksums while data checksums are actively being enabled
+    will abort the current processing.  There is no way to restart from where
+    processing was interrupted.
+   </para>
+
+   <sect3 id="checksums-online-system-impact">
+    <title>Impact on system of online operations</title>
+    <para>
+     Enabling data checksums can cause significant I/O to the system, as all of the
+     database pages will need to be rewritten, and will be written both to the
+     data files and the WAL. The impact may be limited by throttling using the
+     <parameter>cost_delay</parameter> and <parameter>cost_limit</parameter>
+     parameters of the <function>pg_enable_data_checksums</function> function.
+    </para>
+
+    <para>
+     <itemizedlist>
+      <listitem><para>
+       I/O: all pages need to have data checksums calculated and written which
+       will generate a lot of dirty pages that will need to be flushed to disk,
+       as well as WAL logged.
+      </para></listitem>
+      <listitem><para>
+       Replication: When the standby receives the data checksum state change
+       in the WAL stream it will issue a <glossterm linkend="glossary-restartpoint">
+       restartpoint</glossterm> in order to flush the current state into the
+       <filename>pg_control</filename> file.  The restartpoint will flush the
+       current state to disk and will block redo until finished.  This in turn
+       will induce replication lag, which on synchronous standbys also blocks
+       the primary.  Reducing <xref linkend="guc-max-wal-size"/> before the
+       process is started can help with reducing the time it takes for the
+       restartpoint to finish.
+      </para></listitem>
+      <listitem><para>
+       Shutdown/Restart: If the server is shut down or restarted when data
+       checksums are being enabled, the process will not resume and all pages
+       need to be recalculated and rewritten.  Enabling data checksums should
+       be done when there is no need for regular maintenance or during a
+       service window.
+      </para></listitem>
+     </itemizedlist>
+    </para>
+
+    <para>
+     Rewriting all pages is not needed when disabling data checksums, but
+     checkpoints are still required.
+    </para>
+   </sect3>
+
+  </sect2>
  </sect1>
 
   <sect1 id="wal-intro">
